import cliutils, linenoise, os, osproc, sequtils, strutils

proc writeOutput(msg, errMsg: TaintedString, cmd: string): void =
  if not msg.isEmptyOrWhitespace: stdout.writeLine(msg)
  if not errMsg.isEmptyOrWhitespace: stderr.writeLine(errMsg)

when isMainModule:

  if paramCount() == 0:
    stderr.writeLine "cmd_shell: no arguments"
    quit(QuitFailure)

  let cmdPrompt = paramStr(1)
  let cmd = '"' & cmdPrompt & '"'

  let args =
    if paramCount() > 1: commandLineParams()[1..^1].mapIt("'" & $it & "'").join(" ")
    else: ""

  discard historySetMaxLen(
    if existsEnv("HISTSIZE"): (cint)parseInt(getEnv("HISTSIZE"))
    else: (cint)1000)

  var line = readLine(cmdPrompt & "> ")

  while line != nil:
    discard exec(cmd & " " & args & $line, "", [], nil, {poUsePath, poEvalCommand}, writeOutput)
    historyAdd(line)
    line = readLine(cmdPrompt & "> ")
